local toc, data = ...
local AddonId = toc.identifier

WT.Unit.CreateVirtualProperty("nameMini", { "name" },
	function(unit)
		if unit.name and unit.name:len() > 11 then
			nameMini = unit.name:sub(1, 8) .. "..."
			return nameMini
		else
			return unit.name
		end
	end)
	
WT.Unit.CreateVirtualProperty("nameShort", { "name" },
	function(unit)
		if unit.name and unit.name:len() > 14 then
			nameShort = unit.name:sub(1, 11) .. "..."
			return nameShort
		else
			return unit.name
		end
	end)
	
WT.Unit.CreateVirtualProperty("nameMed", { "name" },
	function(unit)
		if unit.name and unit.name:len() > 18 then
			nameMed = unit.name:sub(1, 15) .. "..."
			return nameMed
		else
			return unit.name
		end
	end)
	
WT.Unit.CreateVirtualProperty("subName", { "guild", "nameSecondary" },
    function(unit)
        return unit.guild or unit.nameSecondary or nil
    end)

WT.Unit.CreateVirtualProperty("selfStatus", { "afk" },
	function(unit)
		if unit.afk then
			return "AFK"
		else
			return nil
		end
	end)
	
WT.Unit.CreateVirtualProperty("rgStatus", { "offline", "afk", "health" },
	function(unit)
		if unit.offline then
			return "OFFLINE"
		elseif unit.afk then
			return "AFK"
		elseif unit.dead then
			return "DEAD"
		else
			return nil
		end
	end)
	
WT.Unit.CreateVirtualProperty("pvpFaction", { "race", "pvp" },
	function(unit)
		if not unit.pvp then
			return nil
		elseif unit.race == "bahmi" then
			return "defiant"
		elseif unit.race == "kelari" then
			return "defiant"
		elseif unit.race == "eth" then
			return "defiant"
		elseif unit.race == "highelf" then
			return "guardian"
		elseif unit.race == "mathosian" then
			return "guardian"
		elseif unit.race == "dwarf" then
			return "guardian"
		else
			return nil
		end
	end)
	
WT.Unit.CreateVirtualProperty("cqFaction", { "factionId", "pvp" },
	function(unit)
		if not unit.pvp then
			return nil
		elseif unit.factionId == "f0000000FEDCF3A7E" then
			return "dominion"
		elseif unit.factionId == "f000000117FB54BCE" then
			return "oathsworn"
		elseif unit.factionId == "f000000108924207A" then
			return "nightfall"
		else 
			return nil
		end
	end)

WT.Unit.CreateVirtualProperty("healthText", { "health", "afk", "dead", "offline" },
	function(unit)
		if unit.afk then
			return nil
		elseif unit.dead then
			return nil
		elseif unit.offline then
			return nil
		else
			return true
		end
	end)
	
WT.Unit.CreateVirtualProperty("resourceText", { "resource", "castName", "afk", "dead", "offline" },
	function(unit)
		if unit.castName then
			return nil
		elseif unit.afk then
			return nil
		elseif unit.dead then
			return nil
		elseif unit.offline then
			return nil
		else
			return true
		end
	end)
	
WT.Unit.CreateVirtualProperty("chargeBorder", { "charge" }, 
	function(unit)
		if unit.charge and unit.charge > 0 then
			return 100
		else
			return 0
		end
	end)
	
WT.Unit.CreateVirtualProperty("chargeText", { "charge" },
	function(unit)
		if unit.charge and (unit.charge > 0) then
			return true
		else
			return nil
		end
	end)
	
WT.Unit.CreateVirtualProperty("lowManaColor", { "mana", "manaMax" },
	function(unit)
		if unit.mana and unit.manaMax and unit.manaMax > 0 then
			if (unit.mana / unit.manaMax) <= 0.3 then
				return { r = 1, g = 0.00, b = 0.00, a=0.6 }
			elseif (unit.mana / unit.manaMax) < 0.2 then
				return { r = 1, g = 0.00, b = 0.00, a=.9 }
			end
        end
        return { r = 0.00, g = 0.00, b = 0.00, a=.4 }
    end)

WT.Unit.CreateVirtualProperty("lowHealthColor", { "health", "healthMax" },
	function(unit)
		if unit.health and unit.healthMax and unit.healthMax > 0 then
			if (unit.health / unit.healthMax) < 0.3 then
				return { r = 1, g = 0.00, b = 0.00, a=0.6 }
			elseif (unit.health / unit.healthMax) < 0.2 then
				return { r = 1, g = 0.00, b = 0.00, a=.9 }
			end
        end
        return { r = 0.00, g = 0.00, b = 0.00, a=.4 }
    end)
	
WT.Unit.CreateVirtualProperty("borderBackground", { "name" },
	function(unit)
		if unit.name then
			return 100
		else
			return 0
		end
	end)
	
WT.Unit.CreateVirtualProperty("absorbPercentRight", { "absorb", "healthMax" },
	function(unit)
		if unit.absorb and unit.healthMax and unit.healthMax > 0 then
			local absorb = (unit.absorb / unit.healthMax) * 100
			if absorb > 99 and absorb < 100 then
				absorb = ((absorb-99)/1)*100
				return absorb
			elseif absorb > 100 then
				return 100
			else
				return nil
			end
		else 
			return nil
		end 
	end)
	
WT.Unit.CreateVirtualProperty("absorbPercentLeft", { "absorb", "healthMax" },
	function(unit)
		if unit.absorb and unit.healthMax and unit.healthMax > 0 then
			local absorb = (unit.absorb / unit.healthMax) * 100
			if absorb < 1 and absorb > 0 then
				absorb = (absorb/1)*100
				return absorb
			elseif absorb > 1 then
				return 100
			else
				return nil
			end
		else 
			return nil
		end 
	end)

WT.Unit.CreateVirtualProperty("statusColor", { "vitality", "health", "id", "cleansable", "aggro", "combat", "dead", "afk", "callingColor", "calling", },
	function(unit)
		if unit.cleansable then
			return { r = 1.0, g=0.41, b = 0.71, a=0.8 }
		elseif unit.aggro then
			return { r = 1.00, g = 0.00, b = 0.00, a=0.8 }
		elseif unit.combat then
			return { r = 1.0, g=0.65, b = 0, a=0.8 }
		elseif unit.dead then
			return { r = 0.41, g=0.41, b = 0.41, a=0.8 }
		elseif unit.afk then
			return { r = 0, g=0, b = 0, a=0.8 }
		elseif unit.calling then
			return unit.callingColor
		else 
			return { r = 0, g = 0, b = 0, a = 0 }
		end
	end)
	
WT.Unit.CreateVirtualProperty("statusOrbIndex", { "resource", "alliance", "pvp", "vitality", "health", "id", "cleansable", "aggro", "combat", "dead", "afk", "callingColor", "calling", },
	function(unit)
		if unit.afk then
			return 0
		elseif unit.cleansable then
			return 2
		elseif unit.aggro then
			return 3
		elseif unit.combat then
			return 4
		elseif unit.dead then
			return 5
		elseif unit.charge then
			return 6
		elseif unit.energy then
			return 7 
		elseif unit.power then
			return 8
		else
			return 9
		end
	end)
	
WT.Unit.CreateVirtualProperty("healthColor", { "name" },
	function(unit)
		if unit.name then
			return { r = 0, g = 0.7, b = 0, a = 1 }
		else
			return { r = 0, g=0, b = 0, a=0 }
		end
	end)
	
		
WT.Unit.CreateVirtualProperty("cleanseColor", { "id", "cleansable" },
	function(unit)
		if unit.cleansable then
			return { r = 1.0, g=0.41, b = 0.71, a=.6 }
		else
			return {r=0,g=0,b=0,a=0}
		end
	end)
	
WT.Unit.CreateVirtualProperty("rgRaidCleanse", { "id", "cleansable" },
	function(unit)
		if unit.cleansable then
			return nil
		else
			return true
		end
	end)

	
WT.Unit.CreateVirtualProperty("rgRaidHealth", { "id", "cleansable" },
	function(unit)
		if unit.cleansable then
			return { r = 1.0, g=0.41, b = 0.71, a=.9 }
		else
			return unit.callingColor
		end
	end)
	
WT.Unit.CreateVirtualProperty("cleanseBar", { "id", "cleansable" },
	function(unit)
		if unit.cleansable then
			return true
		else
			return nil
		end
	end)
	
WT.Unit.CreateVirtualProperty("cleanseTextColor", { "id", "cleansable" },
	function(unit)
		if unit.cleansable then
			return { r = 0, g=0, b = 0, a=1 }
		else
			return { r=1, g=1, b=1, a=1 }
		end
	end)
	
WT.Unit.CreateVirtualProperty("unitTargeted", { "playerTarget" },
	function(unit)
		if unit.playerTarget then
			return true
		else
			return nil
		end
	end)
	
WT.Unit.CreateVirtualProperty("unitAggro", { "aggro", "combat" },
	function(unit)
		if unit.aggro then
			return true
		else
			return nil
		end
	end)
	
WT.Unit.CreateVirtualProperty("npcType", { "level", "tier", "guaranteedLoot" },
	function(unit)
		if unit.tier  == "raid" then
			return "Boss"
		elseif unit.tier == "goup" then
			return "Elite"
		elseif unit.guaranteedLoot and unit.tier then
			return "Rare Elite"
		elseif unit.guaranteedLoot then
			return "Rare"
		else
			return nil
		end
	end)
	
WT.Unit.CreateVirtualProperty("labelDisplay", { "nameSecondary", "guild" },
	function(unit)
		if unit.nameSecondary then
			return true
		elseif unit.guild then
			return true
		else
			return nil
		end
	end)
	
WT.Unit.CreateVirtualProperty("levelText", { "level", "tier" },
	function(unit)
		if unit.level == "??" then
			return nil 
		elseif unit.tier == "raid" then
			return nil
		else 
			return unit.level
		end
	end)
	
WT.Unit.CreateVirtualProperty("rangeColor", { "range" },
	function(unit)
		if unit.range > 35 then
			return { r=0.8, g=0, b=0, a=1.0 }
		else 
			return { r=0.9, g=0.9, b=0.9, a=1.0 }
		end
	end)

WT.Unit.CreateVirtualProperty("rangeDisplay", { "range", "afk", "dead", "offline", "warfront" },
	function(unit)
		if unit.range == 0 then
			return nil
		else
			return unit.range
		end
	end)
	
WT.Unit.CreateVirtualProperty("rangeText", { "range", "afk", "dead", "offline" },
	function(unit)
		if unit.range == 0 then
			return nil
		elseif unit.afk then
			return nil
		elseif unit.dead then
			return nil
		elseif unit.offline then
			return nil
		else
			return true
		end
	end)

WT.Unit.CreateVirtualProperty("difficultyColor", { "level", "tier" },
	function(unit)
		if not WT.Player.level then return nil end
		if type(WT.Player.level) == "string" then return nil end
		if not unit.level then return nil end
		if type(unit.level) == "string" then return nil end
		if unit.tier == "raid" then return nil end
		local xpLevel = unit.level - WT.Player.level
			if xpLevel > 5 then
				return { r=0.9, g=0, b=0, a=1.0 }
			elseif xpLevel > 2 and xpLevel <= 5 then
				return { r=0.9, g=0.5, b=0, a=1.0 }
			elseif xpLevel >= -2 and xpLevel <= 2 then
				return { r=0.9, g=0.9, b=0, a=1.0 }
			elseif xpLevel < -2 and xpLevel >= -5 then
				return { r=0, g=0.9, b=0, a=1.0 }
		else
			return { r=0.9, g=0.9, b=0.9, a=1.0 }
		end
	end)
	
WT.Unit.CreateVirtualProperty("levelBorder", { "level", "tier", "guaranteedLoot" },
	function(unit)
		if unit.tier == "raid" then
			return nil
		elseif unit.tier == "group" then
			return "eliteIcon"
		elseif unit.guaranteedLoot and unit.tier then
			return "eliteIcon"
		elseif unit.guaranteedLoot then
			return "normalIcon"
		else
			return "normalIcon"
		end
	end)
	
WT.Unit.CreateVirtualProperty("idBoss", { "level", "tier" },
	function(unit)
		if unit.tier == "raid" then
			return true
		else 
			return nil
		end
	end)
	
WT.Unit.CreateVirtualProperty("levelUnknown", { "level", "tier" },
	function(unit)
		if unit.level == "??" then
			return true
		elseif unit.tier == "raid" then
			return true
		else
			return nil
		end
	end)
	
WT.Unit.CreateVirtualProperty("idElite", { "level", "tier", "guaranteedLoot" },
	function(unit)
		if unit.tier then
			return "eliteBorder"
		elseif unit.guaranteedLoot and unit.tier then
			return "eliteBorder"
		elseif unit.guaranteedLoot then
			return "normalBorder"
		else
			return "normalBorder"
		end
	end)
	
WT.Unit.CreateVirtualProperty("targetBackdropIdElite", { "level", "tier", "relation" },
	function(unit)
		if unit.tier and unit.tagged == "other" and unit.relation == "hostile" then
			return "targetEliteBackdrop_tagged"
		elseif unit.tier then
			return "targetEliteBackdrop"
		elseif unit.tagged == "other" and unit.relation == "hostile" then
			return "targetBackdrop_tagged"
		else 
			return "targetBackdrop"
		end
	end)
	
WT.Unit.CreateVirtualProperty("targetInnerIdElite", { "level", "tier", "guaranteedLoot" },
	function(unit)
		if unit.tier then
			return "targetEliteInnerFrame"
		else
			return "targetInnerFrame"
		end
	end)
	
WT.Unit.CreateVirtualProperty("innerIdEliteTT", { "level", "tier", "guaranteedLoot" },
	function(unit)
		if unit.tier then
			return "eliteInnerFrameTT"
		else
			return "innerFrameTT"
		end
	end)
	
WT.Unit.CreateVirtualProperty("idEliteTT", { "level", "tier", "guaranteedLoot" },
	function(unit)
		if unit.tier then
			return "eliteBorder2"
		elseif unit.guaranteedLoot and unit.tier then
			return "eliteBorder2"
		elseif unit.guaranteedLoot then
			return "normalBorder2"
		else
			return "normalBorder2"
		end
	end)
	
	
WT.Unit.CreateVirtualProperty("taggedCallingColor", { "callingColor", "calling", "tagged", "relation" },
	function(unit)
		if unit.calling then
			return unit.callingColor
		elseif unit.tagged == "other" and unit.relation == "hostile" then
			return { r = 0.4, g = 0.4, b = 0.4, a = 1.0 }
		else
			return { r = 0, g = 0.7, b = 0, a = 1.0 }
		end
	end)
	
--[[	
WT.Unit.CreateVirtualProperty("rgComboIndex", { "combo", "comboUnit" },
	function(unit)
		local img = nil
		local calling = Inspect.Unit.Detail("player").calling
		local combo = unit.combo
		if calling == "rogue" then 
			img = "img/skullComboIndex.png"
		else 
			img = "img/swordComboIndex.png"
			if not combo then return nil end
			if combo == 0 then 
				return nil 
				elseif combo == 1 then return 1 
				elseif combo == 2 then return 2
				elseif combo == 3 then return 3
				elseif combo == 4 then return 4
				elseif combo == 5 then return 5 
				else return nil
			end
		end
	end)
--]]

WT.Unit.CreateVirtualProperty("vitalityDisplay", { "vitality" },
	function(unit)
		if type(unit.vitality) == "number" and unit.vitality < 100 then
			return unit.vitality
		else
			return nil
		end
	end)

WT.Unit.CreateVirtualProperty("wingVitalityIndex", {"vitality", "vitalityMax"}, 
	function(unit)
		local vitality = unit.vitality
		if not vitality then return 0 end 
		if vitality > 90 then 
			return 0
			elseif vitality > 80 then return 1
			elseif vitality > 70 then return 2
			elseif vitality > 60 then return 3
			elseif vitality > 50 then return 4
			elseif vitality > 40 then return 5
			elseif vitality > 30 then return 6
			elseif vitality > 20 then return 7
			elseif vitality > 10 then return 8
			elseif vitality > 0 then return 9
			else return 9
		end
	end)

--[[
WT.Unit.CreateVirtualProperty("vitalityIndex", {"vitality", "vitalityMax"}, 
	function(unit)
		local vitality = unit.vitality
		if not vitality then return nil end 
		if vitality > 90 then 
			return nil
			elseif vitality > 80 then return 0
			elseif vitality > 70 then return 1
			elseif vitality > 60 then return 2
			elseif vitality > 50 then return 3
			elseif vitality > 40 then return 4
			elseif vitality > 30 then return 5
			elseif vitality > 20 then return 6
			elseif vitality > 10 then return 7
			elseif vitality > 0 then return 8
			else return 9
		end
	end)
--]]